<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Programador de Tareas</strong>
    </div>
    <div class="contSecc">
      <div class="titSec">Programador de Tareas</div>
      <v-card>
        <div class="text-left">
          <v-btn
            small
            width="140"
            class="ma-1 mr-1 white--text"
            tile
            depressed
            :disabled="disabledThrow"
            @click="isDialogThrow = true"
            color="green"
          >
            <v-icon>mdi-play</v-icon>
            Ejecutar una vez
          </v-btn>
          <v-btn
            small
            width="120"
            class="ma-1 mr-0 ml-1 white--text"
            tile
            depressed
            :disabled="disabledPause"
            @click="isDialogPause = true"
            color="grey"
          >
            <v-icon>mdi-pause</v-icon>
            Pause
          </v-btn>
          <v-btn
            small
            width="120"
            class="ma-1 mr-0 ml-1 white--text"
            tile
            depressed
            :disabled="disabledResume"
            @click="isDialogResume = true"
            color="orange"
          >
            <v-icon>mdi-step-backward</v-icon>
            Reanudar
          </v-btn>
          <v-btn
            small
            width="120"
            class="ma-1  mr-4 ml-1 white--text"
            tile
            depressed
            @click="isDialogDelete = true"
            :disabled="disabledDelete"
            color="red"
          >
            <v-icon>mdi-trash-can</v-icon>
            Eliminar
          </v-btn>
          <v-btn
            @click="dialog = !dialog"
            small
            depressed
            width="120"
            class="ma-1 white--text"
            tile
            color="blue"
          >
            <v-icon>mdi-plus-thick</v-icon>
            Nueva
          </v-btn>

          <v-btn
            @click="getJobs()"
            class="white--text float-right mt-1 mr-1"
            fab
            depressed
            x-small
            color="yellow darken-2"
          >
            <v-icon>mdi-autorenew</v-icon>
          </v-btn>
        </div>
        <v-card-title class="pa-0 pl-4">
          <v-text-field
            v-model="search"
            append-icon="mdi-magnify"
            label="Buscar tareas"
            single-line
            hide-details
          ></v-text-field>
        </v-card-title>
        <v-data-table
          v-model="jobsSelected"
          :headers="headers"
          :items="jobs"
          :search="search"
          :single-expand="true"
          :expanded.sync="expanded"
          show-expand
          item-key="name"
          show-select
          :loading="isRequestingTable"
          class="elevation-1"
        >
          <template v-slot:expanded-item="{ headers, item }">
            <td :colspan="headers.length">
              <div class="headline mb-1">Salida de Última Ejecución</div>
              <template
                v-if="item.execution && item.execution.healthy_status == 1"
              >
                <pre style="max-height: 500px;overflow: auto; width: 800px;">{{
                  getExecutionInfo(
                    item.execution.last_execution_succcess_result
                  )
                }}</pre>
              </template>
              <template
                v-else-if="item.execution && item.execution.healthy_status == 0"
              >
                <pre style="max-height: 500px;overflow: auto;">{{
                  getExecutionInfo(item.execution.last_execution_error_result)
                }}</pre>
              </template>
              <template v-else>Sin datos de salida.</template>
            </td>
          </template>
          <template v-slot:item.name="{ item }">
            <a
              @click="selectJob(item)"
              class="black--text text-decoration-underline"
            >
              {{ item.name }}
            </a>
          </template>
          <template v-slot:item.status="{ item }">
            <div class="text-center">
              <v-chip small label :color="getColor(item)" dark>
                {{ item.status }}
              </v-chip>
            </div>
          </template>
          <template v-slot:item.when="{ item }">
            {{ cronExpressionToText(item.cron_expression) }}
          </template>
          <template v-slot:item.execution.last_execution_succcess="{ item }">
            <template
              v-if="item.execution && item.execution.last_execution_succcess"
            >
              {{ item.execution.last_execution_succcess }}
            </template>
            <template v-else>--:--.--.---</template>
          </template>
          <template v-slot:item.execution.last_execution_error="{ item }">
            <template
              v-if="item.execution && item.execution.last_execution_error"
            >
              {{ item.execution.last_execution_error }}
            </template>
            <template v-else>--:--.--.---</template>
          </template>
          <template v-slot:item.execution.last_duration="{ item }">
            <template v-if="item.execution && item.execution.last_duration">
              {{ item.execution.last_duration }}
            </template>
            <template v-else>-- : -- : --</template>
          </template>
          <template v-slot:item.execution.healthy_status="{ item }">
            <div class="text-center">
              <template
                v-if="item.execution && item.execution.healthy_status == 1"
                ><v-icon :color="getColorHealthy(item)"
                  >mdi-check-decagram</v-icon
                ></template
              >
              <template
                v-else-if="item.execution && item.execution.healthy_status == 0"
              >
                <v-icon :color="getColorHealthy(item)">mdi-alert-circle</v-icon>
              </template>
              <template v-else>
                <v-icon :color="getColorHealthy(item)">mdi-brightness-1</v-icon>
              </template>
            </div>
          </template>
        </v-data-table></v-card
      >
      <v-row justify="center">
        <v-dialog
          v-model="dialog"
          width="900"
          transition="dialog-bottom-transition"
        >
          <v-card>
            <v-card-title class="pa-0">
              <v-toolbar color="primary">
                <v-btn icon @click="dialog = false">
                  <v-icon>mdi-close</v-icon>
                </v-btn>
                <v-toolbar-title>{{ titleDialog }}</v-toolbar-title>
                <v-spacer></v-spacer>
                <v-toolbar-items>
                  <v-btn text @click="dialog = false">
                    Cancelar
                  </v-btn>
                  <v-btn :loading="isSavingJob" text @click="saveJob">
                    Guardar
                  </v-btn>
                </v-toolbar-items>
              </v-toolbar>
            </v-card-title>
            <v-card-text>
              <v-container fluid>
                <v-row>
                  <v-col cols="12" md="6">
                    <v-text-field
                      v-model="jobSelected.name"
                      label="Nombre"
                      :error="$v.jobSelected.name.$error"
                      :disabled="editing"
                    >
                      <template v-if="$v.jobSelected.name.$error" v-slot:append>
                        <v-popover
                          placement="bottom-end"
                          color="red"
                          offset="16"
                        >
                          <v-icon class color="#fd5151"
                            >mdi-alert-circle</v-icon
                          >
                          <template slot="popover">
                            <div
                              @click="$v.jobSelected.name.$reset"
                              v-close-popover
                            >
                              <div v-if="!$v.jobSelected.name.required">
                                ¡No te olvides de éste campo!
                              </div>
                            </div>
                          </template>
                        </v-popover>
                      </template>
                    </v-text-field>
                  </v-col>
                  <v-col cols="12" md="6">
                    <v-text-field
                      v-model="jobSelected.group"
                      label="Grupo"
                      :error="$v.jobSelected.group.$error"
                      :disabled="editing"
                    >
                      <template
                        v-if="$v.jobSelected.group.$error"
                        v-slot:append
                      >
                        <v-popover
                          placement="bottom-end"
                          color="red"
                          offset="16"
                        >
                          <v-icon class color="#fd5151"
                            >mdi-alert-circle</v-icon
                          >
                          <template slot="popover">
                            <div
                              @click="$v.jobSelected.group.$reset"
                              v-close-popover
                            >
                              <div v-if="!$v.jobSelected.group.required">
                                ¡No te olvides de éste campo!
                              </div>
                            </div>
                          </template>
                        </v-popover>
                      </template>
                    </v-text-field>
                  </v-col>
                  <v-col cols="12" md="12">
                    <v-textarea
                      label="Descripción"
                      v-model="jobSelected.description"
                      no-resize
                      rows="3"
                      :error="$v.jobSelected.description.$error"
                    >
                      <template
                        v-if="$v.jobSelected.description.$error"
                        v-slot:append
                      >
                        <v-popover
                          placement="bottom-end"
                          color="red"
                          offset="16"
                        >
                          <v-icon class color="#fd5151"
                            >mdi-alert-circle</v-icon
                          >
                          <template slot="popover">
                            <div
                              @click="$v.jobSelected.description.$reset"
                              v-close-popover
                            >
                              <div v-if="!$v.jobSelected.description.required">
                                ¡No te olvides de éste campo!
                              </div>
                            </div>
                          </template>
                        </v-popover>
                      </template>
                    </v-textarea>
                  </v-col>
                  <v-col cols="12" md="6">
                    <v-switch
                      v-model="jobSelected.execution_url.url_execute"
                      label="Ejecutar URL"
                    />
                  </v-col>
                  <v-col cols="12" md="6">
                    <v-checkbox
                      v-model="jobSelected.execution_url.url_external"
                      label="Externa"
                      :disabled="disabledExecuteURL"
                    ></v-checkbox>
                  </v-col>
                  <v-col cols="12" md="4">
                    <v-select
                      v-model="jobSelected.execution_url.request_method"
                      :items="requestMethods"
                      :error="
                        $v.jobSelected.execution_url.request_method.$error
                      "
                      :disabled="disabledExecuteURL"
                      label="Metodo"
                    >
                      <template
                        v-if="
                          $v.jobSelected.execution_url.request_method.$error
                        "
                        v-slot:append-outer
                      >
                        <v-popover placement="bottom-end" offset="16">
                          <v-icon class color="#fd5151"
                            >mdi-alert-circle</v-icon
                          >
                          <template slot="popover">
                            <span
                              @click="
                                $v.jobSelected.execution_url.request_method.$reset()
                              "
                              v-close-popover
                            >
                              <span
                                v-if="
                                  !$v.jobSelected.execution_url.request_method
                                    .required
                                "
                                >¡No te olvides de éste campo!</span
                              >
                            </span>
                          </template>
                        </v-popover>
                      </template>
                    </v-select>
                  </v-col>
                  <v-col cols="12" md="8">
                    <v-text-field
                      v-model="jobSelected.execution_url.uri"
                      label="URI"
                      :error="$v.jobSelected.execution_url.uri.$error"
                      :disabled="disabledExecuteURL"
                    >
                      <template
                        v-if="$v.jobSelected.execution_url.uri.$error"
                        v-slot:append
                      >
                        <v-popover
                          placement="bottom-end"
                          color="red"
                          offset="16"
                        >
                          <v-icon class color="#fd5151"
                            >mdi-alert-circle</v-icon
                          >
                          <template slot="popover">
                            <div
                              @click="$v.jobSelected.execution_url.uri.$reset"
                              v-close-popover
                            >
                              <div
                                v-if="
                                  !$v.jobSelected.execution_url.uri.required
                                "
                              >
                                ¡No te olvides de éste campo!
                              </div>
                              <div
                                v-if="!$v.jobSelected.execution_url.uri.valid"
                              >
                                ¡No parece una URL valida!
                              </div>
                            </div>
                          </template>
                        </v-popover>
                      </template>
                    </v-text-field>
                  </v-col>
                  <v-col cols="12" md="12">
                    <v-textarea
                      label="Cuerpo de la solicitud"
                      v-model="jobSelected.execution_url.request_body"
                      :disabled="disabledExecuteURL"
                      no-resize
                      auto-grow
                      rows="1"
                    />
                  </v-col>
                  <v-col cols="12" md="12">
                    <v-textarea
                      label="Cúando...?"
                      :value="cronDescription"
                      readonly
                      disabled
                      no-resize
                      auto-grow
                      rows="1"
                    ></v-textarea>
                    <CronQuartz
                      @description-value="descriptionValue"
                      v-model="jobSelected.cron_expression"
                    />
                  </v-col> </v-row
              ></v-container>
            </v-card-text>
          </v-card>
        </v-dialog>
      </v-row>
    </div>
    <v-dialog v-model="isDialogDelete" persistent max-width="600px">
      <v-card>
        <v-card-title>
          <div class="titModal">
            <strong
              >¿Seguro que deseas eliminar las tareas o tarea
              seleccionadas?</strong
            >
          </div>
        </v-card-title>
        <v-card-text></v-card-text>
        <v-card-actions>
          <v-row justify="center" style="margin-right:0px">
            <v-btn
              class="ma-2"
              dark
              tile
              depressed
              color="secondary"
              @click="isDialogDelete = false"
              >No, cancelar</v-btn
            >
            <v-btn
              class="ma-2"
              depressed
              :loading="isDeleting"
              dark
              tile
              color="primary"
              @click="deleteJobs"
              >Si, continuar</v-btn
            >
          </v-row>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-dialog v-model="isDialogThrow" persistent max-width="600px">
      <v-card>
        <v-card-title>
          <div class="titModal">
            <strong
              >¿Seguro que deseas ejecutar las tareas seleccionadas?</strong
            >
          </div>
        </v-card-title>
        <v-card-text></v-card-text>
        <v-card-actions>
          <v-row justify="center" style="margin-right:0px">
            <v-btn
              class="ma-2"
              dark
              tile
              depressed
              color="secondary"
              @click="isDialogThrow = false"
              >No, cancelar</v-btn
            >
            <v-btn
              class="ma-2"
              depressed
              :loading="isThrowing"
              dark
              tile
              color="primary"
              @click="throwJobs"
              >Si, continuar</v-btn
            >
          </v-row>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-dialog v-model="isDialogPause" persistent max-width="600px">
      <v-card>
        <v-card-title>
          <div class="titModal">
            <strong>¿Seguro que deseas pausar las tareas seleccionadas?</strong>
          </div>
        </v-card-title>
        <v-card-text></v-card-text>
        <v-card-actions>
          <v-row justify="center" style="margin-right:0px">
            <v-btn
              class="ma-2"
              dark
              tile
              depressed
              color="secondary"
              @click="isDialogPause = false"
              >No, cancelar</v-btn
            >
            <v-btn
              class="ma-2"
              depressed
              :loading="isPausing"
              dark
              tile
              color="primary"
              @click="pauseJobs"
              >Si, continuar</v-btn
            >
          </v-row>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-dialog v-model="isDialogResume" persistent max-width="600px">
      <v-card>
        <v-card-title>
          <div class="titModal">
            <strong
              >¿Seguro que deseas reanudar las tareas seleccionadas?</strong
            >
          </div>
        </v-card-title>
        <v-card-text></v-card-text>
        <v-card-actions>
          <v-row justify="center" style="margin-right:0px">
            <v-btn
              class="ma-2"
              dark
              tile
              depressed
              color="secondary"
              @click="isDialogResume = false"
              >No, cancelar</v-btn
            >
            <v-btn
              class="ma-2"
              depressed
              :loading="isResuming"
              dark
              tile
              color="primary"
              @click="resumeJobs"
              >Si, continuar</v-btn
            >
          </v-row>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>
<script>
import { required } from "vuelidate/lib/validators";
import validator from "validator";
import { CommonsQuartz } from "@charbytex/vue-quartz-cron";
import axios from "axios";
export default {
  data() {
    return {
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home"
          }
        },
        {
          text: "Programador de Tareas",
          disabled: true
        }
      ],
      search: "",
      dialog: false,
      jobsSelected: [],
      headers: [
        {
          text: "Nombre",
          align: "start",
          sortable: false,
          value: "name"
        },
        { text: "Grupo", value: "group", sortable: false },
        { text: "Status", value: "status", sortable: false, align: "center" },
        { text: "Descripción", value: "description", sortable: false },
        { text: "Cúando", value: "when", sortable: false },
        {
          text: "Último Éxito",
          value: "execution.last_execution_succcess",
          sortable: true
        },
        {
          text: "Último Fallo",
          value: "execution.last_execution_error",
          sortable: true
        },
        {
          text: "Última Duración",
          value: "execution.last_duration",
          sortable: false
        },
        {
          text: "Salud",
          align: "center",
          value: "execution.healthy_status",
          sortable: false
        }
      ],
      jobs: [],
      expanded: [],
      cronDescription: null,
      isSavingJob: false,
      isDeleting: false,
      isDialogDelete: false,
      isDialogThrow: false,
      isDialogPause: false,
      isDialogResume: false,
      isThrowing: false,
      isPausing: false,
      isResuming: false,
      isGeting: false,
      requestMethods: ["GET", "POST", "PUT", "DELETE"],
      jobSelected: {
        id_job: null,
        name: null,
        group: null,
        cron_expression: "* * * ? * * *",
        description: null,
        execution_url: {
          request_method: null,
          uri: null,
          url_execute: null,
          url_external: null,
          request_body: null
        }
      }
    };
  },
  validations: {
    jobSelected: {
      name: {
        required
      },
      group: {
        required
      },
      cron_expression: {
        required
      },
      description: {
        required
      },
      execution_url: {
        request_method: {
          required(item, parent) {
            if (parent.url_execute) {
              return item !== null;
            }
            return true;
          }
        },
        uri: {
          required(item, parent) {
            if (parent.url_execute) {
              return item !== null;
            }
            return true;
          },
          valid(item, parent) {
            if (parent.url_execute) {
              let isUrlValid = validator.isURL(item);
              return true;
              //return isUrlValid;
            } else {
              return true;
            }
          }
        }
      }
    }
  },
  computed: {
    titleDialog() {
      return this.jobSelected.id_job ? "Modificar tarea" : "Crear tarea";
    },
    editing() {
      return this.jobSelected.id_job ? true : false;
    },
    disabledThrow() {
      return this.jobsSelected.length == 0;
    },
    disabledPause() {
      let jobsNotStarted = [];
      if (this.jobsSelected.length > 0) {
        jobsNotStarted = this.jobsSelected.filter(
          (item) => item.status !== "NORMAL"
        );
        return jobsNotStarted.length > 0;
      } else {
        return true;
      }
    },
    disabledResume() {
      let jobsNotStarted = [];
      if (this.jobsSelected.length > 0) {
        jobsNotStarted = this.jobsSelected.filter(
          (item) => item.status !== "PAUSED"
        );
        return jobsNotStarted.length > 0;
      } else {
        return true;
      }
    },
    disabledDelete() {
      return this.jobsSelected.length == 0;
    },
    disabledExecuteURL() {
      let urlExecute = !this.jobSelected.execution_url.url_execute;
      return urlExecute;
    },
    isRequestingTable() {
      return (
        this.isSavingJob ||
        this.isDeleting ||
        this.isThrowing ||
        this.isPausing ||
        this.isResuming ||
        this.isGeting
      );
    }
  },
  watch: {
    dialog(value) {
      if (!value) {
        this.resetValues();
      }
    }
  },
  methods: {
    getColor(itemJob) {
      if (itemJob.status === "PAUSED") return "grey";
      else if (itemJob.status === "ERROR") return "red";
      else return "teal";
    },
    getColorHealthy(itemJob) {
      if (itemJob.execution) {
        if (itemJob.execution.healthy_status == 1) return "green";
        else return "red";
      } else {
        return "black";
      }
    },
    getExecutionInfo(value) {
      try {
        return JSON.parse(value);
      } catch {
        return value;
      }
    },
    descriptionValue(value) {
      this.cronDescription = value;
    },
    resetValues() {
      this.$v.$reset();
      this.jobSelected = {
        id_job: null,
        name: null,
        group: null,
        cron_expression: "* * * ? * * *",
        description: null,
        execution_url: {
          request_method: null,
          uri: null,
          url_execute: null,
          url_external: null,
          request_body: null
        }
      };
    },
    selectJob(job) {
      let job2 = JSON.parse(JSON.stringify(job));
      this.jobSelected = job2;
      this.dialog = true;
    },
    getJobs() {
      var self = this;
      this.isGeting = true;
      axios
        .get("/jobs/scheduler/secure/get")
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              self.setJobs(data);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.isGeting = false;
        });
    },
    saveJob() {
      this.$v.$touch();
      if (!this.$v.$invalid) {
        var self = this;
        this.isSavingJob = true;
        let requestType;
        let requestAxios;
        if (this.jobSelected.id_job) {
          requestType = "put";
          requestAxios = axios.put(
            "/jobs/scheduler/secure/put",
            this.jobSelected
          );
        } else {
          requestType = "post";
          requestAxios = axios.post(
            "/jobs/scheduler/secure/post",
            this.jobSelected
          );
        }
        requestAxios
          .then((response) => {
            if (response) {
              if (response.data.status_code === 200) {
                self.dialog = false;
                self.getJobs();
              }
            }
          })
          .catch((error) => {
            console.log(error);
          })
          .finally(function() {
            self.isSavingJob = false;
          });
      }
    },
    deleteJobs() {
      var self = this;
      this.isDeleting = true;
      let hasJobDeleted = (idJob) => {
        return this.jobsSelected.filter((itemJob) => itemJob.id_job === idJob);
      };
      axios
        .delete("/jobs/scheduler/secure/delete", { data: this.jobsSelected })
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data.valid) {
                self.getJobs();
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.isDialogDelete = false;
          self.isDeleting = false;
        });
    },
    throwJobs() {
      var self = this;
      this.isThrowing = true;
      axios
        .put("/jobs/scheduler/secure/put/run", this.jobsSelected)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data.valid) {
                self.getJobs();
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.isDialogThrow = false;
          self.isThrowing = false;
        });
    },
    pauseJobs() {
      var self = this;
      this.isPausing = true;
      axios
        .put("/jobs/scheduler/secure/put/pause", this.jobsSelected)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data.valid) {
                self.getJobs();
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.isDialogPause = false;
          self.isPausing = false;
        });
    },
    resumeJobs() {
      var self = this;
      this.isResuming = true;
      axios
        .put("/jobs/scheduler/secure/put/resume", this.jobsSelected)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data.valid) {
                self.getJobs();
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.isDialogResume = false;
          self.isResuming = false;
        });
    },
    setJobs(data) {
      this.jobs = data.filter(
        (item) =>
          item.status !== "NONE" &&
          item.status !== "COMPLETE" &&
          item.cron_expression
      );
    },
    cronExpressionToText(cronExpression) {
      if (cronExpression) {
        let result = CommonsQuartz.cronExpressionToText(cronExpression);
        if (!result.error) {
          return result.description;
        }
      }
      return "Error";
    }
  },
  created() {
    this.getJobs();
  }
};
</script>
